require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&WORDS_BIGENDIAN)) {
    eval 'sub ext2fs_cpu_to_le32 {
        my($x) = @_;
	    eval q( &ext2fs_swab32(($x)));
    }' unless defined(&ext2fs_cpu_to_le32);
    eval 'sub ext2fs_le32_to_cpu {
        my($x) = @_;
	    eval q( &ext2fs_swab32(($x)));
    }' unless defined(&ext2fs_le32_to_cpu);
    eval 'sub ext2fs_cpu_to_le16 {
        my($x) = @_;
	    eval q( &ext2fs_swab16(($x)));
    }' unless defined(&ext2fs_cpu_to_le16);
    eval 'sub ext2fs_le16_to_cpu {
        my($x) = @_;
	    eval q( &ext2fs_swab16(($x)));
    }' unless defined(&ext2fs_le16_to_cpu);
    eval 'sub ext2fs_cpu_to_be32 {
        my($x) = @_;
	    eval q((( &__u32)($x)));
    }' unless defined(&ext2fs_cpu_to_be32);
    eval 'sub ext2fs_be32_to_cpu {
        my($x) = @_;
	    eval q((( &__u32)($x)));
    }' unless defined(&ext2fs_be32_to_cpu);
    eval 'sub ext2fs_cpu_to_be16 {
        my($x) = @_;
	    eval q((( &__u16)($x)));
    }' unless defined(&ext2fs_cpu_to_be16);
    eval 'sub ext2fs_be16_to_cpu {
        my($x) = @_;
	    eval q((( &__u16)($x)));
    }' unless defined(&ext2fs_be16_to_cpu);
} else {
    eval 'sub ext2fs_cpu_to_le32 {
        my($x) = @_;
	    eval q((( &__u32)($x)));
    }' unless defined(&ext2fs_cpu_to_le32);
    eval 'sub ext2fs_le32_to_cpu {
        my($x) = @_;
	    eval q((( &__u32)($x)));
    }' unless defined(&ext2fs_le32_to_cpu);
    eval 'sub ext2fs_cpu_to_le16 {
        my($x) = @_;
	    eval q((( &__u16)($x)));
    }' unless defined(&ext2fs_cpu_to_le16);
    eval 'sub ext2fs_le16_to_cpu {
        my($x) = @_;
	    eval q((( &__u16)($x)));
    }' unless defined(&ext2fs_le16_to_cpu);
    eval 'sub ext2fs_cpu_to_be32 {
        my($x) = @_;
	    eval q( &ext2fs_swab32(($x)));
    }' unless defined(&ext2fs_cpu_to_be32);
    eval 'sub ext2fs_be32_to_cpu {
        my($x) = @_;
	    eval q( &ext2fs_swab32(($x)));
    }' unless defined(&ext2fs_be32_to_cpu);
    eval 'sub ext2fs_cpu_to_be16 {
        my($x) = @_;
	    eval q( &ext2fs_swab16(($x)));
    }' unless defined(&ext2fs_cpu_to_be16);
    eval 'sub ext2fs_be16_to_cpu {
        my($x) = @_;
	    eval q( &ext2fs_swab16(($x)));
    }' unless defined(&ext2fs_be16_to_cpu);
}
if(defined(&NO_INLINE_FUNCS)) {
    if((defined( &__GNUC__)  && (defined( &__i386__) || defined( &__i486__) || defined( &__i586__) || defined( &__mc68000__) || defined( &__sparc__)))) {
	eval 'sub _EXT2_HAVE_ASM_BITOPS_ () {1;}' unless defined(&_EXT2_HAVE_ASM_BITOPS_);
    }
}
if((defined( &INCLUDE_INLINE_FUNCS) || !defined( &NO_INLINE_FUNCS))) {
    if(defined(&INCLUDE_INLINE_FUNCS)) {
	eval 'sub _INLINE_ () { &extern;}' unless defined(&_INLINE_);
    } else {
	if(defined(&__GNUC__)) {
	    eval 'sub _INLINE_ () { &extern  &__inline__;}' unless defined(&_INLINE_);
	} else {
	    eval 'sub _INLINE_ () { &extern  &inline;}' unless defined(&_INLINE_);
	}
    }
    if(((defined (defined(&__GNUC__) ? &__GNUC__ : 0))  && !defined( &_EXT2_USE_C_VERSIONS_)  && (defined( &__i386__) || defined( &__i486__) || defined( &__i586__)))) {
	eval 'sub _EXT2_HAVE_ASM_BITOPS_ () {1;}' unless defined(&_EXT2_HAVE_ASM_BITOPS_);
	eval 'sub _EXT2_HAVE_ASM_SWAB_ () {1;}' unless defined(&_EXT2_HAVE_ASM_SWAB_);
	eval 'sub _EXT2_HAVE_ASM_FINDBIT_ () {1;}' unless defined(&_EXT2_HAVE_ASM_FINDBIT_);
	eval 'sub EXT2FS_ADDR () {(*  &addr);}' unless defined(&EXT2FS_ADDR);
	eval 'sub EXT2FS_CONST_ADDR () {(*( &const \'struct __dummy_h\' *)  &addr);}' unless defined(&EXT2FS_CONST_ADDR);
	if(0) {
	}
	if(defined(&EXT2FS_ENABLE_SWAPFS)) {
	    if(defined(&EXT2FS_REQUIRE_486)) {
	    } else {
	    }
	}
	undef(&EXT2FS_ADDR) if defined(&EXT2FS_ADDR);
    }
    if(defined(&__mc68000__)) {
	eval 'sub _EXT2_HAVE_ASM_BITOPS_ () {1;}' unless defined(&_EXT2_HAVE_ASM_BITOPS_);
    }
    if(defined(&__sparc__)) {
	eval 'sub _EXT2_HAVE_ASM_BITOPS_ () {1;}' unless defined(&_EXT2_HAVE_ASM_BITOPS_);
	unless(defined(&EXT2_OLD_BITOPS)) {
	    if(1) {
	    } else {
	    }
	    if(1) {
	    } else {
	    }
	} else {
	}
    }
    if(!defined( &_EXT2_HAVE_ASM_SWAB_)  && defined( &EXT2FS_ENABLE_SWAPFS)) {
    }
    if(!defined( &_EXT2_HAVE_ASM_FINDBIT_)) {
    }
    if(defined(&EXT2FS_DEBUG_FAST_OPS)) {
    }
    if(defined(&EXT2FS_DEBUG_FAST_OPS)) {
    }
    if(defined(&EXT2FS_DEBUG_FAST_OPS)) {
    }
    if(defined(&EXT2FS_DEBUG_FAST_OPS)) {
    }
    if(defined(&EXT2FS_DEBUG_FAST_OPS)) {
    }
    if(defined(&EXT2FS_DEBUG_FAST_OPS)) {
    }
    if(defined(&EXT2FS_DEBUG_FAST_OPS)) {
    }
    if(defined(&EXT2FS_DEBUG_FAST_OPS)) {
    }
    if(defined(&EXT2FS_DEBUG_FAST_OPS)) {
    }
    undef(&_INLINE_) if defined(&_INLINE_);
}
1;
