require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__MTD_CFI_H__)) {
    eval 'sub __MTD_CFI_H__ () {1;}' unless defined(&__MTD_CFI_H__);
    require 'linux/config.ph';
    require 'linux/delay.ph';
    require 'linux/types.ph';
    require 'linux/interrupt.ph';
    require 'linux/mtd/flashchip.ph';
    require 'linux/mtd/cfi_endian.ph';
    unless(defined(&CONFIG_MTD_CFI_GEOMETRY)) {
	eval 'sub CFIDEV_INTERLEAVE_1 () {(1);}' unless defined(&CFIDEV_INTERLEAVE_1);
	eval 'sub CFIDEV_INTERLEAVE_2 () {(2);}' unless defined(&CFIDEV_INTERLEAVE_2);
	eval 'sub CFIDEV_INTERLEAVE_4 () {(4);}' unless defined(&CFIDEV_INTERLEAVE_4);
	eval 'sub CFIDEV_BUSWIDTH_1 () {(1);}' unless defined(&CFIDEV_BUSWIDTH_1);
	eval 'sub CFIDEV_BUSWIDTH_2 () {(2);}' unless defined(&CFIDEV_BUSWIDTH_2);
	eval 'sub CFIDEV_BUSWIDTH_4 () {(4);}' unless defined(&CFIDEV_BUSWIDTH_4);
    } else {
	if(defined(&CONFIG_MTD_CFI_I1)) {
	    eval 'sub CFIDEV_INTERLEAVE_1 () {(1);}' unless defined(&CFIDEV_INTERLEAVE_1);
	}
	if(defined(&CONFIG_MTD_CFI_I2)) {
	    eval 'sub CFIDEV_INTERLEAVE_2 () {(2);}' unless defined(&CFIDEV_INTERLEAVE_2);
	}
	if(defined(&CONFIG_MTD_CFI_I4)) {
	    eval 'sub CFIDEV_INTERLEAVE_4 () {(4);}' unless defined(&CFIDEV_INTERLEAVE_4);
	}
	if(defined(&CONFIG_MTD_CFI_B1)) {
	    eval 'sub CFIDEV_BUSWIDTH_1 () {(1);}' unless defined(&CFIDEV_BUSWIDTH_1);
	}
	if(defined(&CONFIG_MTD_CFI_B2)) {
	    eval 'sub CFIDEV_BUSWIDTH_2 () {(2);}' unless defined(&CFIDEV_BUSWIDTH_2);
	}
	if(defined(&CONFIG_MTD_CFI_B4)) {
	    eval 'sub CFIDEV_BUSWIDTH_4 () {(4);}' unless defined(&CFIDEV_BUSWIDTH_4);
	}
    }
    if(defined(&CFIDEV_INTERLEAVE_1)) {
	if(defined(&CFIDEV_INTERLEAVE)) {
	    undef(&CFIDEV_INTERLEAVE) if defined(&CFIDEV_INTERLEAVE);
	    eval 'sub CFIDEV_INTERLEAVE () {( ($cfi->{interleave}));}' unless defined(&CFIDEV_INTERLEAVE);
	} else {
	    eval 'sub CFIDEV_INTERLEAVE () { &CFIDEV_INTERLEAVE_1;}' unless defined(&CFIDEV_INTERLEAVE);
	}
	eval 'sub cfi_interleave_is_1 () {
	    eval q(( &CFIDEV_INTERLEAVE ==  &CFIDEV_INTERLEAVE_1));
	}' unless defined(&cfi_interleave_is_1);
    } else {
	eval 'sub cfi_interleave_is_1 () {
	    eval q((0));
	}' unless defined(&cfi_interleave_is_1);
    }
    if(defined(&CFIDEV_INTERLEAVE_2)) {
	if(defined(&CFIDEV_INTERLEAVE)) {
	    undef(&CFIDEV_INTERLEAVE) if defined(&CFIDEV_INTERLEAVE);
	    eval 'sub CFIDEV_INTERLEAVE () {( ($cfi->{interleave}));}' unless defined(&CFIDEV_INTERLEAVE);
	} else {
	    eval 'sub CFIDEV_INTERLEAVE () { &CFIDEV_INTERLEAVE_2;}' unless defined(&CFIDEV_INTERLEAVE);
	}
	eval 'sub cfi_interleave_is_2 () {
	    eval q(( &CFIDEV_INTERLEAVE ==  &CFIDEV_INTERLEAVE_2));
	}' unless defined(&cfi_interleave_is_2);
    } else {
	eval 'sub cfi_interleave_is_2 () {
	    eval q((0));
	}' unless defined(&cfi_interleave_is_2);
    }
    if(defined(&CFIDEV_INTERLEAVE_4)) {
	if(defined(&CFIDEV_INTERLEAVE)) {
	    undef(&CFIDEV_INTERLEAVE) if defined(&CFIDEV_INTERLEAVE);
	    eval 'sub CFIDEV_INTERLEAVE () {( ($cfi->{interleave}));}' unless defined(&CFIDEV_INTERLEAVE);
	} else {
	    eval 'sub CFIDEV_INTERLEAVE () { &CFIDEV_INTERLEAVE_4;}' unless defined(&CFIDEV_INTERLEAVE);
	}
	eval 'sub cfi_interleave_is_4 () {
	    eval q(( &CFIDEV_INTERLEAVE ==  &CFIDEV_INTERLEAVE_4));
	}' unless defined(&cfi_interleave_is_4);
    } else {
	eval 'sub cfi_interleave_is_4 () {
	    eval q((0));
	}' unless defined(&cfi_interleave_is_4);
    }
    unless(defined(&CFIDEV_INTERLEAVE)) {
	die("You\ must\ define\ at\ least\ one\ interleave\ to\ support\!");
    }
    if(defined(&CFIDEV_BUSWIDTH_1)) {
	if(defined(&CFIDEV_BUSWIDTH)) {
	    undef(&CFIDEV_BUSWIDTH) if defined(&CFIDEV_BUSWIDTH);
	    eval 'sub CFIDEV_BUSWIDTH () {( ($map->{buswidth}));}' unless defined(&CFIDEV_BUSWIDTH);
	} else {
	    eval 'sub CFIDEV_BUSWIDTH () { &CFIDEV_BUSWIDTH_1;}' unless defined(&CFIDEV_BUSWIDTH);
	}
	eval 'sub cfi_buswidth_is_1 () {
	    eval q(( &CFIDEV_BUSWIDTH ==  &CFIDEV_BUSWIDTH_1));
	}' unless defined(&cfi_buswidth_is_1);
    } else {
	eval 'sub cfi_buswidth_is_1 () {
	    eval q((0));
	}' unless defined(&cfi_buswidth_is_1);
    }
    if(defined(&CFIDEV_BUSWIDTH_2)) {
	if(defined(&CFIDEV_BUSWIDTH)) {
	    undef(&CFIDEV_BUSWIDTH) if defined(&CFIDEV_BUSWIDTH);
	    eval 'sub CFIDEV_BUSWIDTH () {( ($map->{buswidth}));}' unless defined(&CFIDEV_BUSWIDTH);
	} else {
	    eval 'sub CFIDEV_BUSWIDTH () { &CFIDEV_BUSWIDTH_2;}' unless defined(&CFIDEV_BUSWIDTH);
	}
	eval 'sub cfi_buswidth_is_2 () {
	    eval q(( &CFIDEV_BUSWIDTH ==  &CFIDEV_BUSWIDTH_2));
	}' unless defined(&cfi_buswidth_is_2);
    } else {
	eval 'sub cfi_buswidth_is_2 () {
	    eval q((0));
	}' unless defined(&cfi_buswidth_is_2);
    }
    if(defined(&CFIDEV_BUSWIDTH_4)) {
	if(defined(&CFIDEV_BUSWIDTH)) {
	    undef(&CFIDEV_BUSWIDTH) if defined(&CFIDEV_BUSWIDTH);
	    eval 'sub CFIDEV_BUSWIDTH () {( ($map->{buswidth}));}' unless defined(&CFIDEV_BUSWIDTH);
	} else {
	    eval 'sub CFIDEV_BUSWIDTH () { &CFIDEV_BUSWIDTH_4;}' unless defined(&CFIDEV_BUSWIDTH);
	}
	eval 'sub cfi_buswidth_is_4 () {
	    eval q(( &CFIDEV_BUSWIDTH ==  &CFIDEV_BUSWIDTH_4));
	}' unless defined(&cfi_buswidth_is_4);
    } else {
	eval 'sub cfi_buswidth_is_4 () {
	    eval q((0));
	}' unless defined(&cfi_buswidth_is_4);
    }
    unless(defined(&CFIDEV_BUSWIDTH)) {
	die("You\ must\ define\ at\ least\ one\ bus\ width\ to\ support\!");
    }
    eval 'sub CFI_DEVICETYPE_X8 () {(8/ 8);}' unless defined(&CFI_DEVICETYPE_X8);
    eval 'sub CFI_DEVICETYPE_X16 () {(16/ 8);}' unless defined(&CFI_DEVICETYPE_X16);
    eval 'sub CFI_DEVICETYPE_X32 () {(32/ 8);}' unless defined(&CFI_DEVICETYPE_X32);
    eval 'sub P_ID_NONE () {0;}' unless defined(&P_ID_NONE);
    eval 'sub P_ID_INTEL_EXT () {1;}' unless defined(&P_ID_INTEL_EXT);
    eval 'sub P_ID_AMD_STD () {2;}' unless defined(&P_ID_AMD_STD);
    eval 'sub P_ID_INTEL_STD () {3;}' unless defined(&P_ID_INTEL_STD);
    eval 'sub P_ID_AMD_EXT () {4;}' unless defined(&P_ID_AMD_EXT);
    eval 'sub P_ID_MITSUBISHI_STD () {256;}' unless defined(&P_ID_MITSUBISHI_STD);
    eval 'sub P_ID_MITSUBISHI_EXT () {257;}' unless defined(&P_ID_MITSUBISHI_EXT);
    eval 'sub P_ID_RESERVED () {65535;}' unless defined(&P_ID_RESERVED);
    eval 'sub CFI_MODE_CFI () {0;}' unless defined(&CFI_MODE_CFI);
    eval 'sub CFI_MODE_JEDEC () {1;}' unless defined(&CFI_MODE_JEDEC);
    eval 'sub MAX_CFI_CHIPS () {8;}' unless defined(&MAX_CFI_CHIPS);
    eval 'sub CMD {
        my($x) = @_;
	    eval q( &cfi_build_cmd(($x),  &map,  &cfi));
    }' unless defined(&CMD);
    eval 'sub cfi_read_query {
        my($map,$addr) = @_;
	    eval q({  &if ( &cfi_buswidth_is_1()) {  ($map->{read8})($map, $addr); }  &else  &if ( &cfi_buswidth_is_2()) {  &cfi16_to_cpu( ($map->{read16})($map, $addr)); }  &else  &if ( &cfi_buswidth_is_4()) {  &cfi32_to_cpu( ($map->{read32})($map, $addr)); }  &else { 0; } });
    }' unless defined(&cfi_read_query);
    unless(defined(&min)) {
	eval 'sub min {
	    my($x,$y) = @_;
    	    eval q(( ($x)<($y)?($x):($y) ));
	}' unless defined(&min);
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub cfi_udelay {
        my($us) = @_;
	    eval q({  &udelay($us); });
    }' unless defined(&cfi_udelay);
    eval 'sub cfi_spin_lock {
        my($mutex) = @_;
	    eval q({  &spin_lock_bh($mutex); });
    }' unless defined(&cfi_spin_lock);
    eval 'sub cfi_spin_unlock {
        my($mutex) = @_;
	    eval q({  &spin_unlock_bh($mutex); });
    }' unless defined(&cfi_spin_unlock);
}
1;
