require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__MTD_DOC2000_H__)) {
    eval 'sub __MTD_DOC2000_H__ () {1;}' unless defined(&__MTD_DOC2000_H__);
    require 'linux/mtd/mtd.ph';
    eval 'sub DoC_Sig1 () {0;}' unless defined(&DoC_Sig1);
    eval 'sub DoC_Sig2 () {1;}' unless defined(&DoC_Sig2);
    eval 'sub DoC_ChipID () {0x1000;}' unless defined(&DoC_ChipID);
    eval 'sub DoC_DOCStatus () {0x1001;}' unless defined(&DoC_DOCStatus);
    eval 'sub DoC_DOCControl () {0x1002;}' unless defined(&DoC_DOCControl);
    eval 'sub DoC_FloorSelect () {0x1003;}' unless defined(&DoC_FloorSelect);
    eval 'sub DoC_CDSNControl () {0x1004;}' unless defined(&DoC_CDSNControl);
    eval 'sub DoC_CDSNDeviceSelect () {0x1005;}' unless defined(&DoC_CDSNDeviceSelect);
    eval 'sub DoC_ECCConf () {0x1006;}' unless defined(&DoC_ECCConf);
    eval 'sub DoC_2k_ECCStatus () {0x1007;}' unless defined(&DoC_2k_ECCStatus);
    eval 'sub DoC_CDSNSlowIO () {0x100d;}' unless defined(&DoC_CDSNSlowIO);
    eval 'sub DoC_ECCSyndrome0 () {0x1010;}' unless defined(&DoC_ECCSyndrome0);
    eval 'sub DoC_ECCSyndrome1 () {0x1011;}' unless defined(&DoC_ECCSyndrome1);
    eval 'sub DoC_ECCSyndrome2 () {0x1012;}' unless defined(&DoC_ECCSyndrome2);
    eval 'sub DoC_ECCSyndrome3 () {0x1013;}' unless defined(&DoC_ECCSyndrome3);
    eval 'sub DoC_ECCSyndrome4 () {0x1014;}' unless defined(&DoC_ECCSyndrome4);
    eval 'sub DoC_ECCSyndrome5 () {0x1015;}' unless defined(&DoC_ECCSyndrome5);
    eval 'sub DoC_AliasResolution () {0x101b;}' unless defined(&DoC_AliasResolution);
    eval 'sub DoC_ConfigInput () {0x101c;}' unless defined(&DoC_ConfigInput);
    eval 'sub DoC_ReadPipeInit () {0x101d;}' unless defined(&DoC_ReadPipeInit);
    eval 'sub DoC_WritePipeTerm () {0x101e;}' unless defined(&DoC_WritePipeTerm);
    eval 'sub DoC_LastDataRead () {0x101f;}' unless defined(&DoC_LastDataRead);
    eval 'sub DoC_NOP () {0x1020;}' unless defined(&DoC_NOP);
    eval 'sub DoC_Mil_CDSN_IO () {0x800;}' unless defined(&DoC_Mil_CDSN_IO);
    eval 'sub DoC_2k_CDSN_IO () {0x1800;}' unless defined(&DoC_2k_CDSN_IO);
    if(defined( &__arm__)) {
	eval 'sub ReadDOC_ {
	    my($adr, $reg) = @_;
    	    eval q(((*( &__u32 *)(($adr)+(($reg)<<2)))));
	}' unless defined(&ReadDOC_);
	eval 'sub WriteDOC_ {
	    my($d, $adr, $reg) = @_;
    	    eval q( &do{ *( &__u32 *)(($adr)+(($reg)<<2)) = ( &__u32)$d;  &wmb();}  &while(0));
	}' unless defined(&WriteDOC_);
	eval 'sub DOC_IOREMAP_LEN () {0x8000;}' unless defined(&DOC_IOREMAP_LEN);
    }
 elsif(defined( &__ppc__)) {
	eval 'sub ReadDOC_ {
	    my($adr, $reg) = @_;
    	    eval q(((*( &__u16 *)(($adr)+(($reg)<<1)))));
	}' unless defined(&ReadDOC_);
	eval 'sub WriteDOC_ {
	    my($d, $adr, $reg) = @_;
    	    eval q( &do{ *( &__u16 *)(($adr)+(($reg)<<1)) = ( &__u16)$d;  &wmb();}  &while(0));
	}' unless defined(&WriteDOC_);
	eval 'sub DOC_IOREMAP_LEN () {0x4000;}' unless defined(&DOC_IOREMAP_LEN);
    } else {
	eval 'sub ReadDOC_ {
	    my($adr, $reg) = @_;
    	    eval q( &readb(($adr) + ($reg)));
	}' unless defined(&ReadDOC_);
	eval 'sub WriteDOC_ {
	    my($d, $adr, $reg) = @_;
    	    eval q( &writeb($d, ($adr) + ($reg)));
	}' unless defined(&WriteDOC_);
	eval 'sub DOC_IOREMAP_LEN () {0x2000;}' unless defined(&DOC_IOREMAP_LEN);
    }
    if(defined( &__i386__)) {
	eval 'sub USE_MEMCPY () {1;}' unless defined(&USE_MEMCPY);
    }
    eval 'sub ReadDOC {
        my($adr, $reg) = @_;
	    eval q( &ReadDOC_($adr, &DoC_$reg));
    }' unless defined(&ReadDOC);
    eval 'sub WriteDOC {
        my($d, $adr, $reg) = @_;
	    eval q( &WriteDOC_($d,$adr, &DoC_$reg));
    }' unless defined(&WriteDOC);
    eval 'sub DOC_MODE_RESET () {0;}' unless defined(&DOC_MODE_RESET);
    eval 'sub DOC_MODE_NORMAL () {1;}' unless defined(&DOC_MODE_NORMAL);
    eval 'sub DOC_MODE_RESERVED1 () {2;}' unless defined(&DOC_MODE_RESERVED1);
    eval 'sub DOC_MODE_RESERVED2 () {3;}' unless defined(&DOC_MODE_RESERVED2);
    eval 'sub DOC_MODE_MDWREN () {4;}' unless defined(&DOC_MODE_MDWREN);
    eval 'sub DOC_MODE_CLR_ERR () {0x80;}' unless defined(&DOC_MODE_CLR_ERR);
    eval 'sub DOC_ChipID_Doc2k () {0x20;}' unless defined(&DOC_ChipID_Doc2k);
    eval 'sub DOC_ChipID_DocMil () {0x30;}' unless defined(&DOC_ChipID_DocMil);
    eval 'sub CDSN_CTRL_FR_B () {0x80;}' unless defined(&CDSN_CTRL_FR_B);
    eval 'sub CDSN_CTRL_ECC_IO () {0x20;}' unless defined(&CDSN_CTRL_ECC_IO);
    eval 'sub CDSN_CTRL_FLASH_IO () {0x10;}' unless defined(&CDSN_CTRL_FLASH_IO);
    eval 'sub CDSN_CTRL_WP () {0x8;}' unless defined(&CDSN_CTRL_WP);
    eval 'sub CDSN_CTRL_ALE () {0x4;}' unless defined(&CDSN_CTRL_ALE);
    eval 'sub CDSN_CTRL_CLE () {0x2;}' unless defined(&CDSN_CTRL_CLE);
    eval 'sub CDSN_CTRL_CE () {0x1;}' unless defined(&CDSN_CTRL_CE);
    eval 'sub DOC_ECC_RESET () {0;}' unless defined(&DOC_ECC_RESET);
    eval 'sub DOC_ECC_ERROR () {0x80;}' unless defined(&DOC_ECC_ERROR);
    eval 'sub DOC_ECC_RW () {0x20;}' unless defined(&DOC_ECC_RW);
    eval 'sub DOC_ECC__EN () {0x8;}' unless defined(&DOC_ECC__EN);
    eval 'sub DOC_TOGGLE_BIT () {0x4;}' unless defined(&DOC_TOGGLE_BIT);
    eval 'sub DOC_ECC_RESV () {0x2;}' unless defined(&DOC_ECC_RESV);
    eval 'sub DOC_ECC_IGNORE () {0x1;}' unless defined(&DOC_ECC_IGNORE);
    eval 'sub DOC_ECC_EN () {( &DOC_ECC__EN |  &DOC_ECC_RESV);}' unless defined(&DOC_ECC_EN);
    eval 'sub DOC_ECC_DIS () {( &DOC_ECC_RESV);}' unless defined(&DOC_ECC_DIS);
    eval 'sub MAX_FLOORS () {4;}' unless defined(&MAX_FLOORS);
    eval 'sub MAX_CHIPS () {4;}' unless defined(&MAX_CHIPS);
    eval 'sub MAX_FLOORS_MIL () {4;}' unless defined(&MAX_FLOORS_MIL);
    eval 'sub MAX_CHIPS_MIL () {1;}' unless defined(&MAX_CHIPS_MIL);
    eval 'sub ADDR_COLUMN () {1;}' unless defined(&ADDR_COLUMN);
    eval 'sub ADDR_PAGE () {2;}' unless defined(&ADDR_PAGE);
    eval 'sub ADDR_COLUMN_PAGE () {3;}' unless defined(&ADDR_COLUMN_PAGE);
}
1;
