require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_SUNRPC_SCHED_H_)) {
    eval 'sub _LINUX_SUNRPC_SCHED_H_ () {1;}' unless defined(&_LINUX_SUNRPC_SCHED_H_);
    require 'linux/timer.ph';
    require 'linux/tqueue.ph';
    require 'linux/sunrpc/types.ph';
    require 'linux/wait.ph';
    undef(&CONFIG_RPC_FASTSCHED) if defined(&CONFIG_RPC_FASTSCHED);
    if(defined(&RPC_DEBUG)) {
    }
    if(defined(&RPC_DEBUG)) {
    }
    eval 'sub tk_auth () { ($tk_client->{cl_auth});}' unless defined(&tk_auth);
    eval 'sub tk_xprt () { ($tk_client->{cl_xprt});}' unless defined(&tk_xprt);
    eval 'sub RPC_TASK_ASYNC () {0x1;}' unless defined(&RPC_TASK_ASYNC);
    eval 'sub RPC_TASK_SWAPPER () {0x2;}' unless defined(&RPC_TASK_SWAPPER);
    eval 'sub RPC_TASK_SETUID () {0x4;}' unless defined(&RPC_TASK_SETUID);
    eval 'sub RPC_TASK_CHILD () {0x8;}' unless defined(&RPC_TASK_CHILD);
    eval 'sub RPC_CALL_REALUID () {0x10;}' unless defined(&RPC_CALL_REALUID);
    eval 'sub RPC_CALL_MAJORSEEN () {0x20;}' unless defined(&RPC_CALL_MAJORSEEN);
    eval 'sub RPC_TASK_ROOTCREDS () {0x40;}' unless defined(&RPC_TASK_ROOTCREDS);
    eval 'sub RPC_TASK_DYNAMIC () {0x80;}' unless defined(&RPC_TASK_DYNAMIC);
    eval 'sub RPC_TASK_KILLED () {0x100;}' unless defined(&RPC_TASK_KILLED);
    eval 'sub RPC_IS_ASYNC {
        my($t) = @_;
	    eval q((($t)-> &tk_flags &  &RPC_TASK_ASYNC));
    }' unless defined(&RPC_IS_ASYNC);
    eval 'sub RPC_IS_SETUID {
        my($t) = @_;
	    eval q((($t)-> &tk_flags &  &RPC_TASK_SETUID));
    }' unless defined(&RPC_IS_SETUID);
    eval 'sub RPC_IS_CHILD {
        my($t) = @_;
	    eval q((($t)-> &tk_flags &  &RPC_TASK_CHILD));
    }' unless defined(&RPC_IS_CHILD);
    eval 'sub RPC_IS_SWAPPER {
        my($t) = @_;
	    eval q((($t)-> &tk_flags &  &RPC_TASK_SWAPPER));
    }' unless defined(&RPC_IS_SWAPPER);
    eval 'sub RPC_DO_ROOTOVERRIDE {
        my($t) = @_;
	    eval q((($t)-> &tk_flags &  &RPC_TASK_ROOTCREDS));
    }' unless defined(&RPC_DO_ROOTOVERRIDE);
    eval 'sub RPC_ASSASSINATED {
        my($t) = @_;
	    eval q((($t)-> &tk_flags &  &RPC_TASK_KILLED));
    }' unless defined(&RPC_ASSASSINATED);
    eval 'sub RPC_IS_ACTIVATED {
        my($t) = @_;
	    eval q((($t)-> &tk_active));
    }' unless defined(&RPC_IS_ACTIVATED);
    eval 'sub RPC_DO_CALLBACK {
        my($t) = @_;
	    eval q((($t)-> &tk_callback !=  &NULL));
    }' unless defined(&RPC_DO_CALLBACK);
    eval 'sub RPC_TASK_SLEEPING () {0;}' unless defined(&RPC_TASK_SLEEPING);
    eval 'sub RPC_TASK_RUNNING () {1;}' unless defined(&RPC_TASK_RUNNING);
    eval 'sub RPC_IS_SLEEPING {
        my($t) = @_;
	    eval q(( &test_bit( &RPC_TASK_SLEEPING, ($t)-> &tk_runstate)));
    }' unless defined(&RPC_IS_SLEEPING);
    eval 'sub RPC_IS_RUNNING {
        my($t) = @_;
	    eval q(( &test_bit( &RPC_TASK_RUNNING, ($t)-> &tk_runstate)));
    }' unless defined(&RPC_IS_RUNNING);
    eval 'sub rpc_set_running {
        my($t) = @_;
	    eval q(( &set_bit( &RPC_TASK_RUNNING, ($t)-> &tk_runstate)));
    }' unless defined(&rpc_set_running);
    eval 'sub rpc_clear_running {
        my($t) = @_;
	    eval q(( &clear_bit( &RPC_TASK_RUNNING, ($t)-> &tk_runstate)));
    }' unless defined(&rpc_clear_running);
    eval 'sub rpc_set_sleeping {
        my($t) = @_;
	    eval q(( &set_bit( &RPC_TASK_SLEEPING, ($t)-> &tk_runstate)));
    }' unless defined(&rpc_set_sleeping);
    eval 'sub rpc_clear_sleeping {
        my($t) = @_;
	    eval q( &do {  &smp_mb__before_clear_bit();  &clear_bit( &RPC_TASK_SLEEPING, ($t)-> &tk_runstate);  &smp_mb__after_clear_bit(); }  &while(0));
    }' unless defined(&rpc_clear_sleeping);
    if(defined(&RPC_DEBUG)) {
    }
    unless(defined(&RPC_DEBUG)) {
	eval 'sub RPC_INIT_WAITQ {
	    my($name) = @_;
    	    eval q(( {  &NULL }));
	}' unless defined(&RPC_INIT_WAITQ);
    } else {
	eval 'sub RPC_INIT_WAITQ {
	    my($name) = @_;
    	    eval q(( {  &NULL, $name }));
	}' unless defined(&RPC_INIT_WAITQ);
    }
    if(defined(&RPC_DEBUG)) {
    }
    eval 'sub rpc_malloc {
        my($task,$size) = @_;
	    eval q({  &rpc_allocate( ($task->{tk_flags}), $size); });
    }' unless defined(&rpc_malloc);
    eval 'sub rpc_exit {
        my($task,$status) = @_;
	    eval q({  ($task->{tk_status}) = $status;  ($task->{tk_action}) =  &NULL; });
    }' unless defined(&rpc_exit);
    if(defined(&RPC_DEBUG)) {
	eval 'sub rpc_qname {
	    my($q) = @_;
    	    eval q({  ($q->{name})?  ($q->{name}) : \\"unknown\\"; });
	}' unless defined(&rpc_qname);
    }
}
1;
