require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&PAM_MACROS_H)) {
    eval 'sub PAM_MACROS_H () {1;}' unless defined(&PAM_MACROS_H);
    require 'sys/types.ph';
    require 'string.ph';
    require 'stdlib.ph';
    require 'errno.ph';
    require 'pwd.ph';
    require 'grp.ph';
    require 'stdio.ph';
    eval 'sub x_strdup {
        my($s) = @_;
	    eval q(( ($s) ?  &strdup($s): &NULL ));
    }' unless defined(&x_strdup);
    eval 'sub _pam_overwrite {
        my($x) = @_;
	    eval q( &do {  &register \'char\' * &__xx__;  &if (( &__xx__=($x)))  &while (* &__xx__) * &__xx__++ = ord(\'\\\\0\'); }  &while (0));
    }' unless defined(&_pam_overwrite);
    eval 'sub _pam_drop {
        my($X) = @_;
	    eval q( &do {  &if ($X) {  &free($X); $X= &NULL; } }  &while (0));
    }' unless defined(&_pam_drop);
    eval 'sub _pam_drop_reply {
        my(  $reply,   $replies) = @_;
	    eval q( &do { \'int\'  &reply_i;  &for ( &reply_i=0;  &reply_i<$replies; ++ &reply_i) {  &if ( ($reply[$reply_i]->{resp})) {  &_pam_overwrite( ($reply[$reply_i]->{resp}));  &free( ($reply[$reply_i]->{resp})); } }  &if ($reply)  &free($reply); }  &while (0));
    }' unless defined(&_pam_drop_reply);
    if(defined(&PAM_USER_MATCH)) {
	unless(defined(&PAM_USER_IN_GROUP)) {
	    eval 'sub PAM_USER_IN_GROUP () {1;}' unless defined(&PAM_USER_IN_GROUP);
	}
	unless(defined(&PAM_USER_IN_NETGROUP)) {
	    eval 'sub PAM_USER_IN_NETGROUP () {1;}' unless defined(&PAM_USER_IN_NETGROUP);
	}
    }
    if(defined(&PAM_USER_IN_GROUP)) {
	unless(defined(&PAM_GETPWNAM_R)) {
	    eval 'sub PAM_GETPWNAM_R () {1;}' unless defined(&PAM_GETPWNAM_R);
	}
	unless(defined(&PAM_GETGRNAM_R)) {
	    eval 'sub PAM_GETGRNAM_R () {1;}' unless defined(&PAM_GETGRNAM_R);
	}
    }
    eval 'sub DEFINE_PAM_GETENT {
        my($fn,$qtype,$type) = @_;
	    eval q( &static \'int\'  &_pam_$fn($qtype  &q, $type * &result, \'char\' ** &buf, \'size_t\' * &buf_len, $type ** &res) { \'size_t\'  &length; \'char\' * &buffer, * &tmp; \'int\'  &i;  &memset( &result, 0, $sizeof{ &result}); * &res =  &NULL; * &buf_len =  &length = 0; * &buf =  &buffer =  &NULL;  &do {  &length +=  &BUFSIZ;  &tmp =  &realloc( &buffer,  &length);  &if( &tmp ==  &NULL) {  &free( &buffer);  &return  &ENOMEM; }  &buffer =  &tmp;  &i = $fn( &q,  &result,  &buffer,  &length,  &res);  &if( &i != 0) { * &res =  &NULL; }  &else {  &break; } }  &while( &i ==  &ERANGE);  &if(( &i == 0)  && (* &res !=  &NULL)) { * &buf =  &buffer; * &buf_len =  &length; * &res =  &result; }  &else { * &buf =  &NULL; * &buf_len = 0; * &res =  &NULL; }  &return  &i; });
    }' unless defined(&DEFINE_PAM_GETENT);
    if(defined(&PAM_GETPWNAM_R)) {
    }
    if(defined(&PAM_GETPWUID_R)) {
    }
    if(defined(&PAM_GETGRNAM_R)) {
    }
    if(defined(&PAM_GETGRGID_R)) {
    }
    if(defined(&PAM_GETSPNAM_R)) {
    }
    if(defined(&PAM_USER_IN_GROUP)) {
	if(defined(&HAVE_GETGROUPLIST)) {
	}
    }
    if(defined(&PAM_USER_IN_NETGROUP)) {
	if(defined(&HAVE_YP_GET_DEFAULT_DOMAIN)) {
	    require 'rpcsvc/ypclnt.ph';
	}
	if(defined( &HAVE_GETNETGRENT)  && defined( &HAVE_YP_GET_DEFAULT_DOMAIN)) {
	}
    }
    if(defined(&PAM_USER_MATCH)) {
    }
    if(defined(&DEBUG)) {
	require 'stdio.ph';
	require 'sys/types.ph';
	require 'stdarg.ph';
	require 'errno.ph';
	require 'sys/stat.ph';
	require 'fcntl.ph';
	require 'unistd.ph';
	unless(defined(&_PAM_LOGFILE)) {
	    eval 'sub _PAM_LOGFILE () {"/tmp/pam-debug.log";}' unless defined(&_PAM_LOGFILE);
	}
	if(defined(&O_NOFOLLOW)) {
	} else {
	}
	if(defined(&O_NOFOLLOW)) {
	} else {
	}
	eval 'sub D {
	    my($x) = @_;
    	    eval q( &do {  &_pam_output_debug_info( &__FILE__,  &__FUNCTION__,  &__LINE__);  &_pam_output_debug $x ; }  &while (0));
	}' unless defined(&D);
	eval 'sub _pam_show_mem {
	    my($X,$XS) = @_;
    	    eval q( &do { \'int\'  &i;  &register \'unsigned char\' * &x;  &x = $X;  &fprintf( &stderr, \\"  <start at %p>\\\\n\\", $X);  &for ( &i = 0;  &i < $XS ; ++ &x, ++ &i) {  &fprintf( &stderr, \\"    %02X. <%p:%02X>\\\\n\\",  &i,  &x, * &x); }  &fprintf( &stderr, \\"  <end for %p after %d bytes>\\\\n\\", $X, $XS); }  &while (0));
	}' unless defined(&_pam_show_mem);
	eval 'sub _pam_show_reply {
	    my( $reply,  $replies) = @_;
    	    eval q( &do { \'int\'  &reply_i;  &setbuf( &stderr,  &NULL);  &fprintf( &stderr, \\"array at %p of size %d\\\\n\\",$reply,$replies);  &fflush( &stderr);  &if ($reply) {  &for ( &reply_i = 0;  &reply_i < $replies;  &reply_i++) {  &fprintf( &stderr, \\"  elem# %d at %p: resp = %p, retcode = %d\\\\n\\",  &reply_i, $reply+ &reply_i,  ($reply[$reply_i]->{resp}),  ($reply[$reply_i]->{resp}),  &_retcode);  &fflush( &stderr);  &if ( ($reply[$reply_i]->{resp})) {  &fprintf( &stderr, \\"    resp[%d] = \'%s\'\\\\n\\",  &strlen( ($reply[$reply_i]->{resp})),  ($reply[$reply_i]->{resp}));  &fflush( &stderr); } } }  &fprintf( &stderr, \\"done here\\\\n\\");  &fflush( &stderr); }  &while (0));
	}' unless defined(&_pam_show_reply);
    } else {
	eval 'sub D {
	    my($x) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&D);
	eval 'sub _pam_show_mem {
	    my($X,$XS) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&_pam_show_mem);
	eval 'sub _pam_show_reply {
	    my($reply, $replies) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&_pam_show_reply);
    }
}
1;
